.syntax unified
.cpu cortex-m3
.fpu softvfp
.thumb

.equ  BootRAM, 0xF108F85F

.section	.isr_vector
.type	g_pfnVectors, %object
.size	g_pfnVectors, .-g_pfnVectors

g_pfnVectors:
	.word	_estack
	.word	Reset_Handler
	.space 42*4
	.word	TIM2_IRQHandler
	.space 21*4
	.word	BootRAM          /* @0x108. This is for boot in RAM mode for
                            STM32F10x Medium Density devices. */

.section	.text.TIM2_IRQHandler
.type	TIM2_IRQHandler, %function

TIM2_IRQHandler:
	// Interrupt-Flag löschen
	ldr r0, =0x40000000			// Basis-Adresse TIM2 laden
	ldr r1, [r0, 0x10]			// SR laden
	ands r1, #1					// Mit 1 verunden
	beq 1f						// Wenn 0, return
	mvns r1, r1					// r1 ist 1. Negiere.
	str r1, [r0, 0x10]			// Lösche Interrupt-Flag

	// Pin togglen
	ldr r0, =0x40010800			// Basis-Adresse GPIOA laden
	ldr r1, [r0, 0x0C]			// ODR laden
	and r1, r1, #32				// Nur Bit 5 behalten
	eors r2, r1, #32			// Bit 5 Invertieren
	orr.w	r1, r2, r1, lsl #16
	str r1, [r0, 0x10]			// BSRR beschreiben

	1:
		bx lr

.global Reset_Handler
.section	.text.Reset_Handler
.type	main, %function
Reset_Handler:
	ldr r0, =0x40021000			// RCC-Basisaddresse
	ldr r1, =4
	str r1, [r0, 0x18]			// RCC_APB2ENR beschreiben (GPIOA ein)
	ldr r1, =1
	str r1, [r0, 0x1C]			// TIM2 ein

	ldr r0, =0xE000E100			// NVIC_ISER0
	ldr r1, =0x10000000			// Interrupt 28 (TIM2 Handler)
	str r1, [r0]				// Interrupt einschalten

	ldr r0, =0x40010800			// GPIOA5 auf Output setzen
	ldr r1, =0x44144444
	str r1, [r0]

	ldr r0, =0x40000000			// Basis-Adresse TIM2 laden
	ldr r1, =#7999
	str r1, [r0, 0x28]			// Prescaler TIM2_PSC
	ldr r1, =#499
	str r1, [r0, 0x2C]			// ARR

	ldr r1, =1
	str r1, [r0, 0x0C]			// DIER (Interrupt ein)
	str r1, [r0, 0x14]			// EGR (Timer reinitialisieren)
	str r1, [r0]				// CR1 Timer einschalten

	cpsie i

	1:
		wfi
		b 1b
